//	scandisk.h  -  recursive directory scanner sample code
//
//	This is a part of the MetaKit library.
//	Copyright (c) 1996 Meta Four Software.
//	All rights reserved.
/////////////////////////////////////////////////////////////////////////////

	// The following properties are used in this code
extern c4_ViewProp		pFiles;
extern c4_IntProp		pParent, pSize, pDate;
extern c4_StringProp	pName;

	// Derive from this mixin class to handle status updates and idle time
class cStatusHandler
{
public:
	virtual bool UpdateStatus(const char* text);
};
	
	// Scan a directory tree and return a corresponding structure for it.
	// The data structure of the object returned by this routine is:
	//		[parent:i, name:s, files [name:s, size:i, date:i]]
extern c4_View fScanDirectories(const char* path_, cStatusHandler* =0);

	// Reconstruct the full path name from a subdirectory index in the tree
extern CString fFullPath(c4_View& dirs_, int dirNum_);

/////////////////////////////////////////////////////////////////////////////
// $Id: scandisk.h,v 1.2 1996/12/04 14:49:35 jcw Exp $
